Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 12663)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/browser.py	(revision 12664)
@@ -808,5 +808,5 @@
     manage_applications = True
     pnav = 3
-    display_actions = [[_('Save'), _('Final Submit')],
+    display_actions = [[_('Save'), _('Finally Submit')],
         [_('Add online payment ticket'),_('Remove selected tickets')]]
 
@@ -993,8 +993,8 @@
                 [_('Add online payment ticket'),_('Remove selected tickets')]]
         elif self.context.special and state == PAID:
-            actions = [[_('Save'), _('Final Submit')],
+            actions = [[_('Save'), _('Finally Submit')],
                 [_('Add online payment ticket'),_('Remove selected tickets')]]
         elif state == PAID:
-            actions = [[_('Save'), _('Final Submit')],
+            actions = [[_('Save'), _('Finally Submit')],
                 [_('Remove selected tickets')]]
         return actions
@@ -1054,5 +1054,5 @@
         return
 
-    @action(_('Final Submit'), warning=WARNING)
+    @action(_('Finally Submit'), warning=WARNING)
     def finalsubmit(self, **data):
         if self.upload_success is False:  # False is not None!
Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 12663)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 12664)
@@ -916,5 +916,5 @@
         file_ctrl.add_file(image, filename='myphoto.jpg')
         self.browser.getControl(name="confirm_passport").value = True
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         self.browser.open(self.view_path + '/' + payment_id)
         self.browser.getLink("Download payment slip").click()
@@ -1042,5 +1042,5 @@
         file_ctrl.add_file(image, filename='myphoto.jpg')
         self.browser.getControl(name="confirm_passport").value = True
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         self.browser.open(applicant_path + '/' + payment_id)
         self.browser.getLink("Download payment slip").click()
@@ -1068,11 +1068,11 @@
         self.login()
         self.browser.getLink("Edit application record").click()
-        self.assertFalse('Final Submit' in self.browser.contents)
+        self.assertFalse('Finally Submit' in self.browser.contents)
         IWorkflowInfo(self.applicant).fireTransition('pay')
         self.browser.open(self.edit_path)
-        self.assertTrue('Final Submit' in self.browser.contents)
+        self.assertTrue('Finally Submit' in self.browser.contents)
         self.fill_correct_values() # fill other fields with correct values
         self.browser.getControl("Save").click()
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         # We forgot to upload a passport picture
         self.assertTrue(
@@ -1083,5 +1083,5 @@
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(image, filename='myphoto.jpg')
-        self.browser.getControl("Final Submit").click() # (finally) submit form
+        self.browser.getControl("Finally Submit").click() # (finally) submit form
         # The picture has been uploaded but the form cannot be submitted
         # since the passport confirmation box was not ticked
@@ -1105,5 +1105,5 @@
         self.browser.open(self.edit_path)
         self.browser.getControl(name="confirm_passport").value = True
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         self.assertTrue(
             'Application submitted' in self.browser.contents)
@@ -1114,5 +1114,5 @@
         self.browser.open(self.edit_path)
         self.browser.getControl(name="confirm_passport").value = True
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         self.assertTrue(
             'Application submitted' in self.browser.contents)
@@ -1124,5 +1124,5 @@
             'The requested form is locked' in self.browser.contents)
         self.browser.goBack(count=1)
-        self.browser.getControl("Final Submit").click()
+        self.browser.getControl("Finally Submit").click()
         self.assertTrue(
             'The requested form is locked' in self.browser.contents)