Index: main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser.py	(revision 12671)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser.py	(revision 12684)
@@ -79,4 +79,13 @@
     label = _('Products')
 
+    @property
+    def description(self):
+        lang = self.request.cookies.get('ikoba.language')
+        html = self.context.description_dict.get(lang,'')
+        if html =='':
+            portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
+            html = self.context.description_dict.get(portal_language,'')
+        return html
+
 
 class ProductsContainerManageFormPage(IkobaEditFormPage,
@@ -106,5 +115,10 @@
     @action(_('Save'), style='primary')
     def save(self, **data):
-        return msave(self, **data)
+        msave(self, **data)
+        # Save multilingual dict
+        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
+        desc = getattr(self.context, 'description', None)
+        self.context.description_dict = html2dict(desc, portal_language)
+        return 
 
     @action(_('Cancel'), validator=NullValidator)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containermanagepage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containermanagepage.pt	(revision 12671)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containermanagepage.pt	(revision 12684)
@@ -15,4 +15,5 @@
   <div class="tab-content">
     <div id="tab1" class="active tab-pane">
+      <br />
       <table class="form-table">
         <tbody>
@@ -20,5 +21,4 @@
         </tbody>
       </table>
-      <br /><p i18n:translate="">Setting parameters no yet configured.</p>
       <div tal:condition="view/availableActions">
         <span tal:repeat="action view/actions" tal:omit-tag="">
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containerpage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containerpage.pt	(revision 12671)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/products/browser_templates/containerpage.pt	(revision 12684)
@@ -1,2 +1,7 @@
+<span tal:condition="view/description" tal:omit-tag="">
+  <p tal:content="structure view/description">Description</p>
+  <br /><br />
+</span>
+
 <div i18n:domain="waeup.ikoba" i18n:translate="" tal:condition="python: not len(context.keys())">
 There are no subobjects registered yet.
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/products/container.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/products/container.py	(revision 12671)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/products/container.py	(revision 12684)
@@ -32,4 +32,7 @@
     grok.provides(IProductsContainer)
 
+    def __init__(self, *args, **kw):
+        super(ProductsContainer, self).__init__(*args, **kw)
+        self.description_dict = {}
 
     def addProduct(self, product):
@@ -54,4 +57,6 @@
     def update(self, site, name, logger):
         container = site['products']
+        if not getattr(container, 'description_dict', None):
+            container.description_dict = {}
         for value in container.values():
             if not getattr(value, 'description_dict', None):
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/products/interfaces.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/products/interfaces.py	(revision 12671)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/products/interfaces.py	(revision 12684)
@@ -36,4 +36,13 @@
 
     """
+
+    description_dict = Attribute(
+        'Description as language dictionary with values in html format')
+
+    description = schema.Text(
+        title = _(u'Description'),
+        required = False,
+        description = _(u'Multilingual content in HTML format'),
+        )
 
     def addProduct(product):